using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Herencia.Capas;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_SistemaGestionAlmacen._0_Modelos;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_SistemaGestionAlmacen._1_Datos
{
    public class SGA_InventarioCabecera_TMP_Datos : ABS_Datos
    {
        #region Listado
        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
           
        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {}
        #endregion

        #region Obtener

        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 3;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                  " SELECT " +
                        nameof(SGA_InventarioCabecera_TMP.id) + "," +
                        nameof(SGA_InventarioCabecera_TMP.numeroDocumento) + "," +
                        nameof(SGA_InventarioCabecera_TMP.descripcion) + "," +
                        nameof(SGA_InventarioCabecera_TMP.idDelegacion) + "," +
                        nameof(SGA_InventarioCabecera_TMP.idAlmacen) + "," +
                        nameof(SGA_InventarioCabecera_TMP.idEmpresa) + "," +
                        nameof(SGA_InventarioCabecera_TMP.fecha) + "," +
                        nameof(SGA_InventarioCabecera_TMP.estado) + "," +
                        nameof(SGA_InventarioCabecera_TMP.idEmpleado) + "," +
                        nameof(SGA_InventarioCabecera_TMP.fechaModificacion) +
               " FROM " + nameof(SGA_InventarioCabecera_TMP) +
               " WHERE " + nameof(SGA_InventarioCabecera_TMP.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<SGA_InventarioCabecera_TMP>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar tablas Relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //MAE_Empleados ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idEmpleado != null)
                    {
                        ThreadStart obj_ThreadStart_EMPLEADO = new ThreadStart(Obtener_Empleado_Modelo_Obtener);
                        Thread obj_Thread_EMPLEADO = new Thread(obj_ThreadStart_EMPLEADO);
                        obj_Thread_EMPLEADO.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[0] = true;
                    }

                    //GEN_Delegaciones
                    ThreadStart obj_ThreadStart_DELEGACION = new ThreadStart(Obtener_Delegacion_Modelo_Obtener);
                    Thread obj_Thread_DELEGACION = new Thread(obj_ThreadStart_DELEGACION);
                    obj_Thread_DELEGACION.Start();

                    //GEN_Almacenes
                    ThreadStart obj_ThreadStart_ALMACEN = new ThreadStart(Obtener_Almacen_Modelo_Obtener);
                    Thread obj_Thread_ALMACEN = new Thread(obj_ThreadStart_ALMACEN);
                    obj_Thread_ALMACEN.Start();

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(SGA_InventarioCabecera_TMP_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }

        #region Tablas Relacionadas
        private void Obtener_Empleado_Modelo_Obtener()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MAESTROS + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MAESTROS + "." + Variables.G_STR_LIBRERIA_DATOSMAESTROS);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSMAESTROS_PROCEDIMIENTO_MAEEMPLEADOS_OBTENERMODELO_POR_ID, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_dnm_Modelo_Obtener.idEmpleado };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_dnm_Modelo_Obtener.MAE_Empleados = (MAE_Empleados)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        private void Obtener_Delegacion_Modelo_Obtener()
        {
            try
            {
                g_dnm_Modelo_Obtener.GEN_Delegaciones = Datos_Generales.GEN_Delegaciones_Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idDelegacion);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[1] = true;
            }
        }
        private void Obtener_Almacen_Modelo_Obtener()
        {
            try
            {
                g_dnm_Modelo_Obtener.GEN_Almacenes = Datos_Generales.GEN_Almacenes_Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idAlmacen);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[2] = true;
            }
        }

        #endregion
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region Obtener Para Visor

        #region Listado
        public List<INTERNO_SGA_InventarioCabecera_TMP_Listado_Modelo> Obtener_Para_Visor(DateTime? _dtt_FechaModificacion)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<INTERNO_SGA_InventarioCabecera_TMP_Listado_Modelo> lst_INTERNO_SGA_InventarioCabecera_TMP_Listado_Modelo = new List<INTERNO_SGA_InventarioCabecera_TMP_Listado_Modelo>();
            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL_AUX = " SELECT " +
                                        //
                                        nameof(INTERNO_SGA_InventarioCabecera_TMP_Listado_Modelo.Id) + " = " + nameof(SGA_InventarioCabecera_TMP) + "." + nameof(SGA_InventarioCabecera_TMP.id) + "," +
                                        nameof(INTERNO_SGA_InventarioCabecera_TMP_Listado_Modelo.Estado) + " = " + nameof(SGA_InventarioCabecera_TMP) + "." + nameof(SGA_InventarioCabecera_TMP.estado) + "," +
                                        nameof(INTERNO_SGA_InventarioCabecera_TMP_Listado_Modelo.NumeroDocumento) + " = " + nameof(SGA_InventarioCabecera_TMP) + "." + nameof(SGA_InventarioCabecera_TMP.numeroDocumento) + "," +
                                        nameof(INTERNO_SGA_InventarioCabecera_TMP_Listado_Modelo.Descripcion) + " = " + nameof(SGA_InventarioCabecera_TMP) + "." + nameof(SGA_InventarioCabecera_TMP.descripcion) + "," +
                                        nameof(INTERNO_SGA_InventarioCabecera_TMP_Listado_Modelo.Fecha) + " = " + nameof(SGA_InventarioCabecera_TMP) + "." + nameof(SGA_InventarioCabecera_TMP.fecha) + "," +
                                        nameof(INTERNO_SGA_InventarioCabecera_TMP_Listado_Modelo.FechaModificacion) + " = " + nameof(SGA_InventarioCabecera_TMP) + "." + nameof(SGA_InventarioCabecera_TMP.fechaModificacion) + "," +
                                        nameof(INTERNO_SGA_InventarioCabecera_TMP_Listado_Modelo.Empresa_Id) + " = " + nameof(SGA_InventarioCabecera_TMP) + "." + nameof(SGA_InventarioCabecera_TMP.idEmpresa) + "," +
                                        //MAE_Empleados
                                        nameof(INTERNO_SGA_InventarioCabecera_TMP_Listado_Modelo.Empleado_Id) + " = " + nameof(MAE_Empleados) + "." + nameof(MAE_Empleados.id) + "," +
                                        nameof(INTERNO_SGA_InventarioCabecera_TMP_Listado_Modelo.Empleado_Descripcion) + " = " + nameof(MAE_Empleados) + "." + nameof(MAE_Empleados.nombre) + "," +
                                        //GEN_Delegaciones
                                        nameof(INTERNO_SGA_InventarioCabecera_TMP_Listado_Modelo.Delegacion_Id) + " = " + nameof(GEN_Delegaciones) + "." + nameof(GEN_Delegaciones.id) + "," +
                                        nameof(INTERNO_SGA_InventarioCabecera_TMP_Listado_Modelo.Delegacion_Descripcion) + " = " + nameof(GEN_Delegaciones) + "." + nameof(GEN_Delegaciones.descripcion) +
                                " FROM " + nameof(SGA_InventarioCabecera_TMP) +
                                //MAE_Empleados
                                " LEFT JOIN " + nameof(MAE_Empleados) + " ON " + nameof(SGA_InventarioCabecera_TMP) + "." + nameof(SGA_InventarioCabecera_TMP.idEmpleado) + " = " + nameof(MAE_Empleados) + "." + nameof(MAE_Empleados.id) +
                                //GEN_Delegaciones
                                " LEFT JOIN " + nameof(GEN_Delegaciones) + " ON " + nameof(SGA_InventarioCabecera_TMP) + "." + nameof(SGA_InventarioCabecera_TMP.idDelegacion) + " = " + nameof(GEN_Delegaciones) + "." + nameof(GEN_Delegaciones.id) +
                                " WHERE " +
                                    (_dtt_FechaModificacion!=null ? ("CONVERT(varchar, " + nameof(SGA_InventarioCabecera_TMP) + "." + nameof(SGA_InventarioCabecera_TMP.fechaModificacion) + ", 20) "  + ">'" + _dtt_FechaModificacion.Value.ToString("yyy-MM-dd HH:mm:ss")) + "'" : "1=1");


                //Rellenar el Modelo
                lst_INTERNO_SGA_InventarioCabecera_TMP_Listado_Modelo = obj_Exferia_Entities.Database.SqlQuery<INTERNO_SGA_InventarioCabecera_TMP_Listado_Modelo>(str_SQL_AUX).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(SGA_InventarioCabecera_TMP_Datos) + "/" + nameof(Obtener_Para_Visor), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return lst_INTERNO_SGA_InventarioCabecera_TMP_Listado_Modelo;
        }
        #endregion

        public List<long> Obtener_Ids_Para_Visor()
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<long> lst_Ids = new List<long>();
            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL_AUX = " SELECT " + nameof(SGA_InventarioCabecera_TMP) + "." + nameof(SGA_InventarioCabecera_TMP.id) + " FROM " + nameof(SGA_InventarioCabecera_TMP);

                //Rellenar el Modelo
                lst_Ids = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_AUX).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(SGA_InventarioCabecera_TMP_Datos) + "/" + nameof(Obtener_Ids_Para_Visor), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return lst_Ids;
        }

        #endregion

        #region MODELOS

        #region Modelo Simple
        private SGA_InventarioCabecera_TMP g_mdl_SGA_InventarioCabecera_TMP = null;
        public SGA_InventarioCabecera_TMP Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {

                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(SGA_InventarioCabecera_TMP) + "." + nameof(SGA_InventarioCabecera_TMP.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(SGA_InventarioCabecera_TMP_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_SGA_InventarioCabecera_TMP;
        }
        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                               object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_mdl_SGA_InventarioCabecera_TMP = obj_Exferia_Entities.Database.SqlQuery<SGA_InventarioCabecera_TMP>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(SGA_InventarioCabecera_TMP_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #region Modelo Listado
        private List<SGA_InventarioCabecera_TMP> g_lst_SGA_InventarioCabecera_TMP = null;

        public List<SGA_InventarioCabecera_TMP> Obtener_ModeloListado_Por_Ids(List<long> _lst_Ids)
        {
            try
            {
                if (_lst_Ids != null && _lst_Ids.Count > 0)
                {
                    string str_Filtro_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(SGA_InventarioCabecera_TMP),
                                                                                            nameof(SGA_InventarioCabecera_TMP.id),
                                                                                            G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                            _lst_Ids);

                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                                " WHERE " +
                                                    str_Filtro_IDS;

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     new object[] { });
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(SGA_InventarioCabecera_TMP_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_SGA_InventarioCabecera_TMP;
        }

        #region Ejecutar Consulta

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                      object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_SGA_InventarioCabecera_TMP = obj_Exferia_Entities.Database.SqlQuery<SGA_InventarioCabecera_TMP>(_str_SQL, _arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(SGA_InventarioCabecera_TMP_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                        nameof(SGA_InventarioCabecera_TMP.id) + "," +
                        nameof(SGA_InventarioCabecera_TMP.numeroDocumento) + "," +
                        nameof(SGA_InventarioCabecera_TMP.descripcion) + "," +
                        nameof(SGA_InventarioCabecera_TMP.idDelegacion) + "," +
                        nameof(SGA_InventarioCabecera_TMP.idAlmacen) + "," +
                        nameof(SGA_InventarioCabecera_TMP.idEmpresa) + "," +
                        nameof(SGA_InventarioCabecera_TMP.fecha) + "," +
                        nameof(SGA_InventarioCabecera_TMP.estado) + "," +
                        nameof(SGA_InventarioCabecera_TMP.idEmpleado) + "," +
                        nameof(SGA_InventarioCabecera_TMP.fechaModificacion) +
                " FROM " + nameof(SGA_InventarioCabecera_TMP);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                SGA_InventarioCabecera_TMP mdl_SGA_InventarioCabecera_TMP_AGrabar = (SGA_InventarioCabecera_TMP)_mdl_obj;
                SGA_InventarioCabecera_TMP mdl_SGA_InventarioCabecera_TMP_DatosViejos = new SGA_InventarioCabecera_TMP();

                // Ver si existe ######################################################################
                SGA_InventarioCabecera_TMP mdl_SGA_InventarioCabecera_TMP_Final = Obtener_Modelo_Por_Id(mdl_SGA_InventarioCabecera_TMP_AGrabar.id);
                //#####################################################################################

                //UPDATE
                if (mdl_SGA_InventarioCabecera_TMP_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos Viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_SGA_InventarioCabecera_TMP_Final, mdl_SGA_InventarioCabecera_TMP_DatosViejos, false, false);

                    //Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_SGA_InventarioCabecera_TMP_AGrabar, mdl_SGA_InventarioCabecera_TMP_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(SGA_InventarioCabecera_TMP) +
                                            " SET " +
                                                nameof(SGA_InventarioCabecera_TMP.numeroDocumento) + "=@numeroDocumento," +
                                                nameof(SGA_InventarioCabecera_TMP.descripcion) + "=@descripcion," +
                                                nameof(SGA_InventarioCabecera_TMP.idDelegacion) + "=@idDelegacion," +
                                                nameof(SGA_InventarioCabecera_TMP.idAlmacen) + "=@idAlmacen," +
                                                nameof(SGA_InventarioCabecera_TMP.idEmpresa) + "=@idEmpresa," +
                                                nameof(SGA_InventarioCabecera_TMP.fecha) + "=@fecha," +
                                                nameof(SGA_InventarioCabecera_TMP.estado) + "=@estado," +
                                                nameof(SGA_InventarioCabecera_TMP.idEmpleado) + "=@idEmpleado," +
                                                nameof(SGA_InventarioCabecera_TMP.fechaModificacion) + "=getDate()" +
                                            " WHERE " +
                                                nameof(SGA_InventarioCabecera_TMP.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@numeroDocumento", mdl_SGA_InventarioCabecera_TMP_Final.numeroDocumento),
                        new SqlParameter("@descripcion", mdl_SGA_InventarioCabecera_TMP_Final.descripcion),
                        new SqlParameter("@idDelegacion", mdl_SGA_InventarioCabecera_TMP_Final.idDelegacion),
                        new SqlParameter("@idAlmacen", mdl_SGA_InventarioCabecera_TMP_Final.idAlmacen),
                        new SqlParameter("@idEmpresa", mdl_SGA_InventarioCabecera_TMP_Final.idEmpresa),
                        new SqlParameter("@fecha", mdl_SGA_InventarioCabecera_TMP_Final.fecha),
                        mdl_SGA_InventarioCabecera_TMP_Final.estado != null
                            ?   new SqlParameter("@estado", mdl_SGA_InventarioCabecera_TMP_Final.estado)
                            :   new SqlParameter("@estado",  DBNull.Value),
                        mdl_SGA_InventarioCabecera_TMP_Final.idEmpleado != null
                            ?   new SqlParameter("@idEmpleado", mdl_SGA_InventarioCabecera_TMP_Final.idEmpleado.Value)
                            :   new SqlParameter("@idEmpleado",  DBNull.Value),
                        new SqlParameter("@id", mdl_SGA_InventarioCabecera_TMP_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_SGA_InventarioCabecera_TMP_Final.id;
                }
                ///INSERT
                else
                {
                    mdl_SGA_InventarioCabecera_TMP_Final = new SGA_InventarioCabecera_TMP();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos Del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_SGA_InventarioCabecera_TMP_AGrabar, mdl_SGA_InventarioCabecera_TMP_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(SGA_InventarioCabecera_TMP) +
                                                " (" +
                                                      nameof(SGA_InventarioCabecera_TMP.numeroDocumento) + "," +
                                                      nameof(SGA_InventarioCabecera_TMP.descripcion) + "," +
                                                      nameof(SGA_InventarioCabecera_TMP.idDelegacion) + "," +
                                                      nameof(SGA_InventarioCabecera_TMP.idAlmacen) + "," +
                                                      nameof(SGA_InventarioCabecera_TMP.idEmpresa) + "," +
                                                      nameof(SGA_InventarioCabecera_TMP.fecha) + "," +
                                                      nameof(SGA_InventarioCabecera_TMP.estado) + "," +
                                                      nameof(SGA_InventarioCabecera_TMP.idEmpleado) + "," +
                                                      nameof(SGA_InventarioCabecera_TMP.fechaModificacion) +
                                                " ) " +
                                                " OUTPUT INSERTED." + nameof(SGA_InventarioCabecera_TMP.id) +
                                                " VALUES " +
                                                " ( " +
                                                    "@numeroDocumento," +
                                                    "@descripcion," +
                                                    "@idDelegacion," +
                                                    "@idAlmacen," +
                                                    "@idEmpresa," +
                                                    "@fecha," +
                                                    "@estado," +
                                                    "@idEmpleado," +
                                                    "getDate()" +
                                                " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@numeroDocumento", mdl_SGA_InventarioCabecera_TMP_Final.numeroDocumento),
                        new SqlParameter("@descripcion", mdl_SGA_InventarioCabecera_TMP_Final.descripcion),
                        new SqlParameter("@idDelegacion", mdl_SGA_InventarioCabecera_TMP_Final.idDelegacion),
                        new SqlParameter("@idAlmacen", mdl_SGA_InventarioCabecera_TMP_Final.idAlmacen),
                        new SqlParameter("@idEmpresa", mdl_SGA_InventarioCabecera_TMP_Final.idEmpresa),
                        new SqlParameter("@fecha", mdl_SGA_InventarioCabecera_TMP_Final.fecha),
                        mdl_SGA_InventarioCabecera_TMP_Final.estado != null
                            ?   new SqlParameter("@estado", mdl_SGA_InventarioCabecera_TMP_Final.estado)
                            :   new SqlParameter("@estado",  DBNull.Value),
                        mdl_SGA_InventarioCabecera_TMP_Final.idEmpleado != null
                            ?   new SqlParameter("@idEmpleado", mdl_SGA_InventarioCabecera_TMP_Final.idEmpleado.Value)
                            :   new SqlParameter("@idEmpleado",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                //Grabar un registro de trazabilidad con los datos de la transaccion ralizada
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(SGA_InventarioCabecera_TMP), mdl_SGA_InventarioCabecera_TMP_DatosViejos, mdl_SGA_InventarioCabecera_TMP_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(SGA_InventarioCabecera_TMP_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {

                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                #region Delete
                string str_SQL_Delete = " DELETE FROM " + nameof(SGA_InventarioCabecera_TMP) +
                                        " WHERE " +
                                            nameof(SGA_InventarioCabecera_TMP.id) + "=@id";
                //Parametros
                object[] arr_Parametros_Delete = new object[]
                {
                    new SqlParameter("@id", _lng_id)
                };
                #endregion

                //Update
                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);


                //Devolver tambien el objeto
                mdl_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(SGA_InventarioCabecera_TMP_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            return null;
        }
        #endregion
    }
}
